package com.ibm.mda.uxjsf.transform;
/*
 * Created on Apr 6, 2004
 *
 */
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * @author jim conallen
 *
 */
public class Fragment {
	
	private String text = "";
	
	public void append(String text) {
		this.text += text;
	}
	
	public void append(char c) {
		text += ("" + c);
	}

	public String getTagName() {
		String name = null;
		if( isTag() ) {
			int start = 1;
			int len = text.length();
			if( text.charAt(1) == '/' ) 
				start = 2;
			for(int i=start;i<len;i++) {
				char c = text.charAt(i);
				if( !Character.isLetterOrDigit(c) && c!=':') {
					name = text.substring(start,i);
					break;
				} 		
			}
		}
		return name;
	}
	
	public String getTagId() {
		String id = null;
		if( text != null ) {
			id = findTagAttribute(text, "id");
		}
		return id;
	}
	
	public boolean isTag(){
		return (text != null &&
				text.length()>2 && 
				text.charAt(0) == '<' && 
				text.charAt(text.length()-1) == '>');
	}
	
	public boolean isEmptyTag(){
		return (text != null &&
				text.length()>2 &&
				text.charAt(0) == '<' && 
				text.charAt(text.length()-2) != '/'  && 
				text.charAt(text.length()-1) == '>');
	}
	
	public boolean isEndTag(){
		return (text != null &&
				text.length()>2 &&
				text.charAt(0) == '<' && 
				text.charAt(1) == '/'  && 
				text.charAt(text.length()-1) == '>');
	}

	public boolean isStartTag(){
		return (text != null &&
				text.length()>2 &&
				text.charAt(0) == '<' && 
				text.charAt(text.length()-1) == '>');
	}


	public String getText() {
		return text;
	}
	
	public void setText(String text) {
		this.text = text;
	}
	
	public Map getAttributes(){
		HashMap attributes = new HashMap();
		String sansEnds = text.substring(1,text.length()-1);
		StringTokenizer st = new StringTokenizer(sansEnds, " \t<>\"\\=", true);
		String value = "";
		String name = null;
		String token = null;
		String prev = null;
		boolean inString = false;
		boolean escape = false;
		boolean inAttrs = false;
		String attrName = null;
		boolean attrValueNext = false;
		while( st.hasMoreTokens() ) {
			token = st.nextToken();
			if( !token.equals("") ) {
				if( !escape && token.equals("\"") ){
					inString = !inString;
				} else if( !inString && attrValueNext ) {
					if( value.equals("") ) {
						attributes.put(attrName,token);
					} else {
						attributes.put(attrName,value);
					}
					attrValueNext = false;
				} else if( token.equals("\\")){
					escape = true;
				} else if( inString )	{
					value += token;
				} else if( token.equals("=") ) {
					attrValueNext = true;
					value = "";				
				} else if( !inAttrs ) {
					inAttrs = true;
					name = token;
				} else if( !token.trim().equals("") && !token.equals("/") ) {
					attrName = token; 
				} 
			}
		}
	
		return attributes;		
	}
	
	
	private static String findTagAttribute(String tag, String attributeName) {
		StringTokenizer st = new StringTokenizer(tag, " \t\n\r\f<>\\\"=", true);
		String prevToken = null;
		String token = null;
		String idValue = null;
		boolean inString = false;
		boolean lookingForIdValue = false;
		while( st.hasMoreTokens() ) {
			prevToken = token;
			token = st.nextToken();
			
			if( token.equals("\"") && !prevToken.equals("\\") ) {
				inString  = !inString;
				if( !inString ) {
					if( lookingForIdValue == true) {
						lookingForIdValue = false;
						break;
					} 
				}
			}
			
			if( !inString && token.equals(attributeName) ) lookingForIdValue = true; 
			
			if( lookingForIdValue ) {
				if( inString ) {
					if( idValue == null ) 
						idValue = ""; 
					else 
						idValue += token;
				} 
			}
		}
		
		return idValue;		
	}

	public Fragment(String text) {
		this.text = text;
	}

	public Fragment(char c) {
		this.text = ("" + c);
	}

}
