/*
 * Created on Apr 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.mda.uxjsf.transform;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Vector;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.ibm.xde.mda.delegates.MdaAssociation;
import com.ibm.xde.mda.delegates.MdaAssociationEnd;
import com.ibm.xde.mda.delegates.MdaAttribute;
import com.ibm.xde.mda.delegates.MdaClass;
import com.ibm.xde.mda.delegates.MdaDependency;
import com.ibm.xde.mda.delegates.MdaNamedModelElement;
import com.ibm.xde.mda.delegates.MdaPackage;
import com.ibm.xde.mda.util.MdaResolver;
import com.rational.rxe.IRXEAssociation;
import com.rational.rxe.IRXEAssociationEnd;
import com.rational.rxe.IRXEAssociationEnds;
import com.rational.rxe.IRXEAssociations;
import com.rational.rxe.IRXEClass;
import com.rational.rxe.IRXEClassProxy;
import com.rational.rxe.IRXEDependency;
import com.rational.rxe.IRXEDependencyProxy;
import com.rational.rxe.IRXEElement;
import com.rational.rxe.IRXERelationship;
import com.rational.rxe.IRXERelationships;

/**
 * @author jconalle
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Screen {
	
	private Element root;
	private Document document;
	private MdaClass impl = null;
	private JSP jsp = new JSP();
	
	public Screen( MdaClass impl ) {
		this.impl = impl;
	}
	
	public Screen( IRXEElement rxeElm ) throws IOException {
		IRXEClass rxeCls = new IRXEClassProxy(rxeElm);
		MdaClass mdaCls = new MdaClass(rxeCls);
		impl = mdaCls;
	}
	public String getId() throws IOException {
		return impl.getID();
	}
	
	public String getDescription() throws IOException {
		return impl.getDescription();
	}
	
	public MdaAssociationEnd[] getNavCaseEnds() throws IOException {
		Vector v = new Vector();
 		MdaAssociationEnd mdaEnd = null;
		IRXEAssociations associations = impl.getAssociationRelationships();
		int count = associations.getCount();
		for(int i=1;i<=count;i++) {
			mdaEnd = null;
			IRXEAssociation rxeAssoc = associations.getAssociationByPosition(i); 
			IRXEAssociationEnds ends = rxeAssoc.getAssociationEnds();
			IRXEAssociationEnd end1 = ends.getAssociationEndByPosition(1);
			IRXEAssociationEnd end2 = ends.getAssociationEndByPosition(2);
			String kind1 = end1.getNavigationKind();
			if( kind1.equals("directed") ) {
				String name = end1.getName();
				String role = end1.getRole();
				// make sure that this screen is the consumer end of the assoc
				if( end2.getElement().getID().equals(impl.getID())) {
					mdaEnd = new MdaAssociationEnd(end1);
				}
			}
			// just in case something strange when on with the model lets check
			// the other end just in case.
			String kind2 = end2.getNavigationKind();
			if( kind2.equals("directed") ) {
				String name = end2.getName();
				String role = end2.getRole();
				// make sure that this screen is the consumer end of the assoc
				if( end1.getElement().getID().equals(impl.getID())) {
					mdaEnd = new MdaAssociationEnd(end2);
				}
			}
			
			if( mdaEnd != null ) {
				IRXEElement rxeElm = mdaEnd.getElement();
				if( rxeElm.getObjectKind().equals("class") ) {
					IRXEClass rxeCls = new IRXEClassProxy(rxeElm);
					MdaClass mdaClass = new MdaClass(rxeCls);
					if( mdaClass.isStereotyped("UX_2a", "screen") ) {
						v.add(mdaEnd);						
					}
				}
			}
			MdaAssociation mdaAssoc = new MdaAssociation(rxeAssoc);
		}
		
		MdaAssociationEnd ends[] = {};
		ends = (MdaAssociationEnd[]) v.toArray(ends);
		return ends;
	}
	
	
	/*
	 * JSP methods
	 */	

	public void writeJSP(IFolder webRoot) throws Exception {
		String path = getRelativeScreenPath();
		IFile file = webRoot.getFile(path);
		if( !file.exists() ) {
			File initialFile = UX_to_JSF_DesignTransformer.getFileInPlugin("templates/empty-jsp.txt");
			UX_to_JSF_DesignTransformer.copyFile(initialFile, file);
		}
		
		UX_to_JSF_DesignTransformer.writeln("\tParsing " + file.getFullPath().toString() );
		jsp.parseFile(file);
		
		// now we can do the updates to the JSP to include all the tags specified in the model
		UX_to_JSF_DesignTransformer.writeln("\t\tupdating output tags...");
		updateScreenTags();
		
		// do the same for all forms that are iplied to be in the screen.
		UX_to_JSF_DesignTransformer.writeln("\t\tupdating input tags...");
		updateFormTags();
		
		// remove any tags that with an id that are not in the model
		
		// finally saved the updated file.
		UX_to_JSF_DesignTransformer.writeln("\t\tsaving updated JSP.");
		jsp.saveFile(file);
	}
	
	public String getFilename() throws IOException{
		// process it as a valid variable name
		String className = impl.getName().trim();
		String filename = normalizeName(className);
		filename += ".jsp"; 
		return filename;
	}
	
	private String normalizeName(String name) {
		String normal = "";
		for(int i=0;i<name.length();i++){
			char c = name.charAt(i);
			if( Character.isLetterOrDigit(c) ){
				normal += c;
			} else {
				normal += '_';
			}
		}
		return normal;		 
	}
	
	
	public String getRelativeScreenPath() throws IOException {
		String path = "";
		String jspTag = impl.getTaggedValueAsString("JSF_1a", "JSP Filename");
		if( jspTag != null && !jspTag.equals("") ){
			// then this is the override
			path = jspTag;
		} else {
			// compute the name and path by walking up the package hierarchy 
			// until we hit a site
			path = "/" + getFilename();
			IRXEElement container = impl.getContainer();
			boolean walking = true;
			while( container != null && walking) {
				if( container.getObjectKind().equals("package") ){
					MdaPackage pkg = new MdaPackage(container);
					if( pkg.isStereotyped("UX_2a", "site") ) {
						// stop here this is the web context root
						walking = false;
					} else {
						String name = normalizeName(container.getName());
						path = "/" + name + path;
						container = container.getContainer();
					}
				} else {
					walking = false;
				}
			}
			if( container == null ) {
				// then no site was found and we have a potential error condition
			} 
		}
		return path;
	}

	/*
	 * Tag methods
	 */
	
	private void updateScreenTags() throws IOException{
		MdaAttribute attributes[] = impl.getMdaAttributes();
		for(int i=0;i<attributes.length;i++) {
			MdaAttribute attr = attributes[i];
			updateTag(attr);
		}
	}
	
	private void updateFormTags() throws IOException {
		MdaAssociation associations[] = impl.getMdaAssociations();
		for(int i=0;i<associations.length;i++) {
			MdaAssociation association = associations[i];
			IRXERelationships relationships = association.getRelationships();
			int count = relationships.getCount();
			for(int r=1;r<=count;r++) {
				IRXERelationship relationship = relationships.getRelationshipByPosition(r);
				String kind = relationship.getObjectKind();
				if( kind.equalsIgnoreCase("dependency") ) {
					IRXEDependency rxeDep = new IRXEDependencyProxy(relationship);
					MdaDependency mdaDep = new MdaDependency(rxeDep);  	// we create a mda element since there are 
																		// outstanding defects in the RXE implementation
					MdaNamedModelElement mdaSupplier = mdaDep.getMdaSupplier();
					MdaNamedModelElement resolved = MdaResolver.recognizeMdaType(mdaSupplier);
					if( resolved instanceof MdaClass ) {
						MdaClass mdaCls = (MdaClass) resolved;
						String stereotypes = mdaCls.getStereotypesAsString(",").toLowerCase();
						if(stereotypes.indexOf("form" )>=0) {
							MdaAttribute attributes[] = mdaCls.getMdaAttributes();
							for(int a=0;a<attributes.length;a++) {
								MdaAttribute attr = attributes[a];
								updateTag(attr);
							}
						}
					}
				}
			}
		}
	}
	
	private void updateTag(MdaAttribute attr) throws IOException {
		String id = UX_to_JSF_DesignTransformer.normalizeName(attr.getName());
			
		String stereotypes = attr.getStereotypesAsString(",");
		// only choose the first JSF_1a stereotype
		String stereotype = null;
		int p1 = stereotypes.indexOf("JSF_1a::");
		if( p1 >= 0 ) {
			p1 += 8; // position it just after the profile name
			int p2 = stereotypes.indexOf(',',p1);
			if( p2>0 ) {
				stereotype = stereotypes.substring(p1,p2);
			} else {
				stereotype = stereotypes.substring(p1);
			}
			TagDefinition tagDef = (TagDefinition) tagDefinitions.get(stereotype);
			if( tagDef != null ) {
				String tagStr = tagDef.buildTag(attr);
				Fragment tag = jsp.getTagbyId(id);
				if( tag == null ) {
					// then need to add it
					tagStr += "\r\n";
					Fragment frag = jsp.insertNewTag(tagStr);
				} else {
					// we need to update/replace it.
					tag.setText(tagStr);
				}
			}
		}
	}
	
	
	/*
	 * Tag definitions 
	 */
	 
	private static HashMap tagDefinitions = null;
	static { 
		tagDefinitions = new HashMap();
		tagDefinitions.put("command button", new TagDefinition("command button", "commandButton", new String[] { "action", "actionListener", "immediate", "rendered", "accesskey", "alt", "dir", "disabled", "image", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "style", "styleClass", "tabindex", "title", "type", "binding" } ) );
		tagDefinitions.put("command link", new TagDefinition("command link", "commandLink", new String[] { "action", "actionListener", "immediate", "rendered", "accesskey", "charset", "coords", "dir", "hreflang", "lang", "onblur", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "rel", "rev", "shape", "style", "styleClass", "tabindex", "target", "title", "type", "binding" } ) );
		tagDefinitions.put("graphic", new TagDefinition("graphic", "graphicImage", new String[] { "rendered", "url", "alt", "dir", "height", "ismap", "lang", "longdesc", "onclick", "ondblclick", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "style", "styleClass", "title", "usemap", "width", "binding" } ) );
		tagDefinitions.put("hidden", new TagDefinition("hidden", "inputHidden", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "binding" } ) );
		tagDefinitions.put("secret", new TagDefinition("secret", "inputSecret", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "alt", "dir", "disabled", "lang", "maxlength", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "redisplay", "size", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("textbox", new TagDefinition("textbox", "inputText", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "alt", "dir", "disabled", "lang", "maxlength", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "size", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("textarea", new TagDefinition("textarea", "inputTextarea", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "cols", "dir", "disabled", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "rows", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("single message", new TagDefinition("single message", "message", new String[] { "for", "rendered", "showDetail", "showSummary", "errorClass", "errorStyle", "fatalClass", "fatalStyle", "infoClass", "infoStyle", "style", "styleClass", "title", "tooltip", "warnClass", "warnStyle", "binding" } ) );
		tagDefinitions.put("messages", new TagDefinition("messages", "messages", new String[] { "globalOnly", "rendered", "showDetail", "showSummary", "errorClass", "errorStyle", "fatalClass", "fatalStyle", "infoClass", "infoStyle", "layout", "style", "styleClass", "title", "tooltip", "warnClass", "warnStyle", "binding" } ) );
		tagDefinitions.put("format", new TagDefinition("format", "outputFormat", new String[] { "converter", "rendered", "escape", "style", "styleClass", "title", "binding" } ) );
		tagDefinitions.put("label", new TagDefinition("label", "outputLabel", new String[] { "converter", "rendered", "accesskey", "dir", "for", "lang", "onblur", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("hlink", new TagDefinition("hlink", "outputLink", new String[] { "converter", "rendered", "accesskey", "charset", "coords", "dir", "hreflang", "lang", "onblur", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "rel", "rev", "shape", "style", "styleClass", "tabindex", "target", "title", "type", "binding" } ) );
		tagDefinitions.put("outtext", new TagDefinition("outtext", "outputText", new String[] { "converter", "rendered", "escape", "style", "styleClass", "title", "binding" } ) );
		tagDefinitions.put("checkbox", new TagDefinition("checkbox", "selectBooleanCheckbox", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "dir", "disabled", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("many checkbox", new TagDefinition("many checkbox", "selectManyCheckbox", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "border", "dir", "disabled", "disabledClass", "enabledClass", "lang", "layout", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("many listbox", new TagDefinition("many listbox", "selectManyListbox", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "dir", "disabled", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "size", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("many menu", new TagDefinition("many menu", "selectManyMenu", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "dir", "disabled", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "size", "style", "styleClass", "tabindex", "title" } ) );
		tagDefinitions.put("listbox", new TagDefinition("listbox", "selectOneListbox", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "dir", "disabled", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "size", "style", "styleClass", "tabindex", "title", "binding" } ) );
		tagDefinitions.put("menu", new TagDefinition("menu", "selectOneMenu", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "dir", "disabled", "lang", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "size", "style", "styleClass", "tabindex", "title" } ) );
		tagDefinitions.put("radio", new TagDefinition("radio", "selectOneRadio", new String[] { "converter", "immediate", "rendered", "required", "validator", "valueChangeListener", "accesskey", "border", "dir", "disabled", "disabledClass", "enabledClass", "lang", "layout", "onblur", "onchange", "onclick", "ondblclick", "onfocus", "onkeydown", "onkeypress", "onkeyup", "onmousedown", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onselect", "readonly", "style", "styleClass", "tabindex", "title", "binding" } ) );
	};

}
