/*
 * Created on Apr 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.mda.uxjsf.transform;

import java.io.IOException;

import com.ibm.xde.mda.delegates.MdaAttribute;

/**
 * @author jim conallen
 *
 */
public class TagDefinition {
	private String stereotype = null;
	private String tagName = null;
	private String tagAttributes[] = null;
	
	public String buildTag(MdaAttribute attr) throws IOException {
		String tagStr = null;
		if( attr.isStereotyped("JSF_1a", stereotype ) ) {
			String id = UX_to_JSF_DesignTransformer.normalizeName(attr.getName());
			tagStr = "<h:" + tagName + " id=\"" + id + "\"";

			String value = attr.getDefaultValue();
			if( value != null && value.length()>0 ) {
				value = UX_to_JSF_DesignTransformer.encode(value); // escape any quotes or ampersands
				tagStr += " value=\"" + value + "\"";
			} 
			
			for(int i=0;i<tagAttributes.length;i++) {
				if( !attr.isTaggedValueADefault("JSF_1a", tagAttributes[i]) ) {
					String tagAttribute = tagAttributes[i];
					String tv = attr.getTaggedValueAsString("JSF_1a", tagAttribute);
					if( tv != null ) {
						tv = UX_to_JSF_DesignTransformer.encode(tv);  // escape any embedded quotes or ampersands
						tagStr += " " + tagAttribute + "=\"" + tv + "\"";
					}
				}
			}
						
			tagStr += "/>";
		}
		
		return tagStr;
	}
	
	
	public TagDefinition(String stereotype, String tagName, String[] tagAttributes) {
		this.stereotype = stereotype;
		this.tagName = tagName;
		this.tagAttributes = tagAttributes;
	}
	
	private TagDefinition(){}

}
