/*
 * Created on Nov 18, 2003
 */
package com.ibm.mda.uxjsf.ui;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.jface.preference.FieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.widgets.Composite;

import com.ibm.mda.uxjsf.UxJsfPlugin;

/**
 * @author dubauski
 *
 * XDE 1.5, 
 * IBM Rational Software 2003
 */
public class UX_to_JSF_DesignParameters {
	private static FieldEditorPreferencePage _host = null;
	
	public static final String P_INPUT_MODEL_FILENAME = "inputModelFilename_UX_to_JSF";
	public static final String P_CONFIG_FILENAME = "configFilename_UX_to_JSF";
	public static final String P_SITE_PACKAGE = "sitePackage_UX_to_JSF";
	public static final String P_WEB_FOLDER = "webFolder_UX_to_JSF";
	public static final String P_CODE_MODEL_FILENAME = "codeModelFilename_UX_to_JSF";

	private static ArrayList _editors = new ArrayList(); 

	/**
	 * 
	 * @param host
	 */
	public static void initialize(FieldEditorPreferencePage host) {
		setHost(host);
		
		IPreferenceStore store = UxJsfPlugin.getDefault().getPreferenceStore();
		getHost().setPreferenceStore(store);
		getHost().setDescription("A demonstration of a preference page implementation");
		initializeDefaults();
	}
	
	/**
	 * Sets the default values of the preferences.
	 */
	private static void initializeDefaults() {
		IPreferenceStore store = getHost().getPreferenceStore();
	}
	
	private static void clearFields() {
		_editors.clear();
	}
	
	private static void addField(FieldEditor editor) {
		_editors.add(editor);
	}
	
	public static Iterator getFields() {
		return _editors.iterator();
	}
	
	/**
	 * Defines visual representation (GUI controls) for 
	 * transformation parameters
	 * 
	 * @param parent - containing composite
	 * 
	 */
	public static void createFieldEditors(Composite parent) {
		clearFields();
		
		// define your visual representation (GUI controls) 
		// for transformation parameters. Call addField() function
		// and pass any subclass of FieldEditor as a parameter.
		// Following subclasses are already available:
		// FileFieldEditor, StringFieldEditor, DirectoryFieldEditor,
		// BooleanFieldEditor, ColorFieldEditor, FontFieldEditor, PathEditor,
		// IntegerFieldEditor, RadioGroupFieldEditor.
		addField(new FileFieldEditor(P_INPUT_MODEL_FILENAME,"&Input model file:", parent));
		addField(new StringFieldEditor(P_CONFIG_FILENAME,"&JSF config file:", parent));
		addField(new StringFieldEditor(P_SITE_PACKAGE,"&Site package:", parent));
		addField(new StringFieldEditor(P_WEB_FOLDER,"&Web folder:", parent));
		addField(new FileFieldEditor(P_CODE_MODEL_FILENAME,"&Code model:", parent));
		
	}

	private static void setHost(FieldEditorPreferencePage host) {
		UX_to_JSF_DesignParameters._host = host;
	}

	private static FieldEditorPreferencePage getHost() {
		return _host;
	}
}
