package com.ibm.mda.uxjsf.ui.preferences;

import java.util.Iterator;

import org.eclipse.jface.preference.FieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import com.ibm.mda.uxjsf.ui.UX_to_JSF_DesignParameters;


/**
 * This class represents a preference page that
 * is contributed to the Preferences dialog. By 
 * subclassing <samp>FieldEditorPreferencePage</samp>, we
 * can use the field support built into JFace that allows
 * us to create a page that is small and knows how to 
 * save, restore and apply itself.
 * <p>
 * This page is used to modify preferences only. They
 * are stored in the preference store that belongs to
 * the main plug-in class. That way, preferences can
 * be accessed directly via the preference store.
 */
public class UX_to_JSF_DesignPreferencePage
	extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {

	public UX_to_JSF_DesignPreferencePage() {
		super(GRID);
		UX_to_JSF_DesignParameters.initialize(this);
	}
	
	/**
	 * Creates the field editors. Field editors are abstractions of
	 * the common GUI blocks needed to manipulate various types
	 * of preferences. Each field editor knows how to save and
	 * restore itself.
	 */
	public void createFieldEditors() {
		Composite parent = getFieldEditorParent();
		
		UX_to_JSF_DesignParameters.createFieldEditors(parent);
		Iterator iter = UX_to_JSF_DesignParameters.getFields();
		while (iter.hasNext()) {
			FieldEditor element = (FieldEditor) iter.next();
			addField(element);
		}
	}
	
	public void init(IWorkbench workbench) {
	}
}

